Index: /pjproject/trunk/pjsip-apps/src/pjsua/winrt/gui/uwp/VoipBackEnd/MyApp.h
===================================================================
--- /pjproject/trunk/pjsip-apps/src/pjsua/winrt/gui/uwp/VoipBackEnd/MyApp.h	(revision 5539)
+++ /pjproject/trunk/pjsip-apps/src/pjsua/winrt/gui/uwp/VoipBackEnd/MyApp.h	(revision 5539)
@@ -0,0 +1,271 @@
+/* $Id*/
+/*
+* Copyright (C) 2016 Teluu Inc. (http://www.teluu.com)
+*
+* This program is free software; you can redistribute it and/or modify
+* it under the terms of the GNU General Public License as published by
+* the Free Software Foundation; either version 2 of the License, or
+* (at your option) any later version.
+*
+* This program is distributed in the hope that it will be useful,
+* but WITHOUT ANY WARRANTY; without even the implied warranty of
+* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+* GNU General Public License for more details.
+*
+* You should have received a copy of the GNU General Public License
+* along with this program; if not, write to the Free Software
+* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+*/
+
+#pragma once
+#include <pjsua2.hpp>
+#include <collection.h>
+
+namespace VoipBackEnd
+{
+    typedef int TransportId;
+
+    typedef Platform::Collections::Vector<Platform::String^> StringVector;
+    typedef Windows::Foundation::Collections::IVector<Platform::String^> 
+	IStringVector;
+
+    typedef public enum class INV_STATE
+    {
+	PJSIP_INV_STATE_NULL,	      /**< Before INVITE is sent or received */
+	PJSIP_INV_STATE_CALLING,      /**< After INVITE is sent		     */
+	PJSIP_INV_STATE_INCOMING,     /**< After INVITE is received.	     */
+	PJSIP_INV_STATE_EARLY,	      /**< After response with To tag.	     */
+	PJSIP_INV_STATE_CONNECTING,   /**< After 2xx is sent/received.	     */
+	PJSIP_INV_STATE_CONFIRMED,    /**< After ACK is sent/received.	     */
+	PJSIP_INV_STATE_DISCONNECTED, /**< Session is terminated.	     */
+    } INV_STATE;
+
+    class ImpLogWriter : public pj::LogWriter
+    {
+    public:
+	virtual void write(const pj::LogEntry &entry);
+    };
+
+    /* Account related data type. */
+    public ref struct OnRegStateParamRT sealed
+    {
+	OnRegStateParamRT();
+
+	property pj_status_t status
+	{
+	    pj_status_t get();
+	};
+
+	property unsigned code 
+	{
+	    unsigned get();
+	};
+
+	property Platform::String^ reason
+	{
+	    Platform::String^ get();
+	};
+
+	property int expiration
+	{
+	    int get();
+	};
+
+    internal:
+	OnRegStateParamRT(const pj::OnRegStateParam& param);
+
+    private:
+	pj::OnRegStateParam* inPtr;	    
+
+	~OnRegStateParamRT();
+    };
+
+    public ref struct CallInfoRT sealed
+    {	
+	property Platform::String^ localUri
+	{
+	    Platform::String^ get();
+	}
+
+	property Platform::String^ localContact
+	{
+	    Platform::String^ get();	    
+	}
+
+	property Platform::String^ remoteUri
+	{
+	    Platform::String^ get();
+	}
+
+	property Platform::String^ remoteContact
+	{
+	    Platform::String^ get();
+	}
+
+	property INV_STATE state
+	{
+	    INV_STATE get();
+	};
+
+    internal:
+	CallInfoRT(const pj::CallInfo& info);
+
+    private:
+	pj::CallInfo* inPtr;
+
+	~CallInfoRT();
+
+    };
+
+    public interface class IntAccount
+    {
+    public:
+	virtual void onRegState(OnRegStateParamRT^ prm);
+	virtual void onIncomingCall(CallInfoRT^ info);
+    };
+
+    class ImpAccount : public pj::Account
+    {
+    public:
+	void setCallback(IntAccount^ callback);
+
+	virtual void onIncomingCall(pj::OnIncomingCallParam& prm);
+	virtual void onRegState(pj::OnRegStateParam& prm);
+
+	~ImpAccount() {};
+
+    private:
+	IntAccount^ cb;
+    };
+
+    /* Call related data type. */
+    public ref class CallOpParamRT sealed
+    {
+    public:
+	CallOpParamRT();
+
+	property unsigned statusCode
+	{
+	    unsigned get();
+	    void set(unsigned val);
+	}
+
+	property Platform::String^ reason {
+	    Platform::String^ get();
+	    void set(Platform::String^ val);
+	}
+
+    internal:
+	pj::CallOpParam* getPtr();
+
+    private:
+	pj::CallOpParam* inPtr;
+
+	~CallOpParamRT();
+    };
+
+    public interface class IntCall
+    {
+
+    public:
+	virtual void onCallState(CallInfoRT^ info);	    
+    };
+
+    class ImpCall : public pj::Call
+    {	    
+    public:	    	    
+	ImpCall(pj::Account& account, int call_id);
+	virtual ~ImpCall() {};
+
+	void setCallback(IntCall^ callback);
+
+	virtual void onCallState(pj::OnCallStateParam& prm);
+	virtual void onCallMediaState(pj::OnCallMediaStateParam& prm);	    
+
+    private:
+	IntCall^ cb;
+    };
+
+    public ref class AccountInfo sealed
+    {
+    public:
+	property Platform::String^ id {
+	    Platform::String^ get();
+	}
+	property Platform::String^ registrar {
+	    Platform::String^ get();
+	}
+	property Platform::String^ proxy {
+	    Platform::String^ get();
+	}
+	property Platform::String^ username {
+	    Platform::String^ get();
+	}
+	property Platform::String^ password {
+	    Platform::String^ get();
+	}
+    internal:
+	AccountInfo(pj::AccountConfig* accConfig);
+    private:
+	pj::AccountConfig* cfg;
+    };
+
+    /* App class. */
+    public ref class MyAppRT sealed
+    {
+    public:
+	static property MyAppRT^ Instance {
+	    MyAppRT^ get();
+	}
+
+	void init(IntAccount^ iAcc, IntCall^ iCall);
+	void deInit();
+
+	/* Util */
+	void writeLog(int level, Platform::String^ message);
+
+	/* Call handling. */
+	void hangupCall();
+	void answerCall(CallOpParamRT^ prm);
+	void makeCall(Platform::String^ dst_uri);	
+	CallInfoRT^ getCallInfo();
+
+	/* Thread handling. */
+	void registerThread(Platform::String^ name);
+	bool isThreadRegistered();
+
+	/* Account handling. */
+	AccountInfo^ getAccountInfo();
+
+	void modifyAccount(Platform::String^ id, Platform::String^ registrar, 
+			   Platform::String^ proxy, Platform::String^ username, 
+			   Platform::String^ password);
+
+    internal:
+	pj_bool_t handleIncomingCall(int callId);
+
+    private:
+	MyAppRT();
+	~MyAppRT();
+
+	void loadConfig();
+	void saveConfig();
+
+	static MyAppRT^ singleton;
+
+	ImpLogWriter* logWriter;
+	pj::Endpoint ep;
+
+	/* Configs */
+	pj::EpConfig* epConfig;
+	pj::AccountConfig* accConfig;
+	pj::TransportConfig* sipTpConfig;
+
+	std::string appDir;
+	ImpAccount* account;
+	ImpCall* activeCall;
+
+	IntAccount^ intAcc;
+	IntCall^ intCall;
+    };
+}
Index: /pjproject/trunk/pjsip-apps/src/pjsua/winrt/gui/uwp/VoipBackEnd/VoipBackEnd.vcxproj
===================================================================
--- /pjproject/trunk/pjsip-apps/src/pjsua/winrt/gui/uwp/VoipBackEnd/VoipBackEnd.vcxproj	(revision 5539)
+++ /pjproject/trunk/pjsip-apps/src/pjsua/winrt/gui/uwp/VoipBackEnd/VoipBackEnd.vcxproj	(revision 5539)
@@ -0,0 +1,278 @@
+﻿<?xml version="1.0" encoding="utf-8"?>
+<Project DefaultTargets="Build" ToolsVersion="14.0" xmlns="http://schemas.microsoft.com/developer/msbuild/2003">
+  <ItemGroup Label="ProjectConfigurations">
+    <ProjectConfiguration Include="Debug|ARM">
+      <Configuration>Debug</Configuration>
+      <Platform>ARM</Platform>
+    </ProjectConfiguration>
+    <ProjectConfiguration Include="Debug|Win32">
+      <Configuration>Debug</Configuration>
+      <Platform>Win32</Platform>
+    </ProjectConfiguration>
+    <ProjectConfiguration Include="Debug|x64">
+      <Configuration>Debug</Configuration>
+      <Platform>x64</Platform>
+    </ProjectConfiguration>
+    <ProjectConfiguration Include="Release|ARM">
+      <Configuration>Release</Configuration>
+      <Platform>ARM</Platform>
+    </ProjectConfiguration>
+    <ProjectConfiguration Include="Release|Win32">
+      <Configuration>Release</Configuration>
+      <Platform>Win32</Platform>
+    </ProjectConfiguration>
+    <ProjectConfiguration Include="Release|x64">
+      <Configuration>Release</Configuration>
+      <Platform>x64</Platform>
+    </ProjectConfiguration>
+  </ItemGroup>
+  <ItemGroup Condition="'$(API_Family)'=='UWP'">
+    <ProjectReference Include="..\..\..\..\..\..\build\libpjproject.vcxproj">
+      <Project>{23d7679c-764c-4e02-8b29-bb882ceeefe2}</Project>
+    </ProjectReference>
+  </ItemGroup>
+  <PropertyGroup Label="Globals">
+    <ProjectGuid>{fc9cbb95-624c-4ce8-86a8-3ab5a415aa65}</ProjectGuid>
+    <Keyword>WindowsRuntimeComponent</Keyword>
+    <ProjectName>VoipBackEnd</ProjectName>
+    <RootNamespace>VoipBackEnd</RootNamespace>
+    <DefaultLanguage>en-US</DefaultLanguage>
+    <MinimumVisualStudioVersion>14.0</MinimumVisualStudioVersion>
+    <AppContainerApplication>true</AppContainerApplication>
+    <ApplicationType>Windows Store</ApplicationType>
+    <WindowsTargetPlatformVersion>10.0.10586.0</WindowsTargetPlatformVersion>
+    <WindowsTargetPlatformMinVersion>10.0.10240.0</WindowsTargetPlatformMinVersion>
+    <ApplicationTypeRevision>10.0</ApplicationTypeRevision>
+  </PropertyGroup>
+  <Import Project="$(VCTargetsPath)\Microsoft.Cpp.Default.props" />
+  <PropertyGroup Condition="'$(Configuration)|$(Platform)'=='Debug|Win32'" Label="Configuration">
+    <ConfigurationType>DynamicLibrary</ConfigurationType>
+    <UseDebugLibraries>true</UseDebugLibraries>
+    <PlatformToolset>v140</PlatformToolset>
+  </PropertyGroup>
+  <PropertyGroup Condition="'$(Configuration)|$(Platform)'=='Debug|ARM'" Label="Configuration">
+    <ConfigurationType>DynamicLibrary</ConfigurationType>
+    <UseDebugLibraries>true</UseDebugLibraries>
+    <PlatformToolset>v140</PlatformToolset>
+  </PropertyGroup>
+  <PropertyGroup Condition="'$(Configuration)|$(Platform)'=='Debug|x64'" Label="Configuration">
+    <ConfigurationType>DynamicLibrary</ConfigurationType>
+    <UseDebugLibraries>true</UseDebugLibraries>
+    <PlatformToolset>v140</PlatformToolset>
+  </PropertyGroup>
+  <PropertyGroup Condition="'$(Configuration)|$(Platform)'=='Release|Win32'" Label="Configuration">
+    <ConfigurationType>DynamicLibrary</ConfigurationType>
+    <UseDebugLibraries>false</UseDebugLibraries>
+    <WholeProgramOptimization>true</WholeProgramOptimization>
+    <PlatformToolset>v140</PlatformToolset>
+  </PropertyGroup>
+  <PropertyGroup Condition="'$(Configuration)|$(Platform)'=='Release|ARM'" Label="Configuration">
+    <ConfigurationType>DynamicLibrary</ConfigurationType>
+    <UseDebugLibraries>false</UseDebugLibraries>
+    <WholeProgramOptimization>true</WholeProgramOptimization>
+    <PlatformToolset>v140</PlatformToolset>
+  </PropertyGroup>
+  <PropertyGroup Condition="'$(Configuration)|$(Platform)'=='Release|x64'" Label="Configuration">
+    <ConfigurationType>DynamicLibrary</ConfigurationType>
+    <UseDebugLibraries>false</UseDebugLibraries>
+    <WholeProgramOptimization>true</WholeProgramOptimization>
+    <PlatformToolset>v140</PlatformToolset>
+  </PropertyGroup>
+  <!-- Import common config -->
+  <Import Project="..\..\..\..\..\..\..\build\vs\pjproject-vs14-common-config.props" />
+  <Import Project="$(VCTargetsPath)\Microsoft.Cpp.props" />
+  <ImportGroup Label="PropertySheets" Condition="'$(Configuration)|$(Platform)'=='Debug|ARM'">
+    <Import Project="..\..\..\..\..\..\..\build\vs\pjproject-vs14-arm-common-defaults.props" />
+    <Import Project="..\..\..\..\..\..\..\build\vs\pjproject-vs14-debug-static-defaults.props" />
+  </ImportGroup>
+  <ImportGroup Label="PropertySheets" Condition="'$(Configuration)|$(Platform)'=='Debug|Win32'">
+    <Import Project="..\..\..\..\..\..\..\build\vs\pjproject-vs14-win32-common-defaults.props" />
+    <Import Project="..\..\..\..\..\..\..\build\vs\pjproject-vs14-debug-static-defaults.props" />
+  </ImportGroup>
+  <ImportGroup Label="PropertySheets" Condition="'$(Configuration)|$(Platform)'=='Debug|x64'">
+    <Import Project="..\..\..\..\..\..\..\build\vs\pjproject-vs14-win64-common-defaults.props" />
+    <Import Project="..\..\..\..\..\..\..\build\vs\pjproject-vs14-debug-static-defaults.props" />
+  </ImportGroup>  
+  <ImportGroup Label="PropertySheets" Condition="'$(Configuration)|$(Platform)'=='Release|ARM'">
+    <Import Project="..\..\..\..\..\..\..\build\vs\pjproject-vs14-arm-common-defaults.props" />
+    <Import Project="..\..\..\..\..\..\..\build\vs\pjproject-vs14-release-dynamic-defaults.props" />
+  </ImportGroup>
+  <ImportGroup Label="PropertySheets" Condition="'$(Configuration)|$(Platform)'=='Release|Win32'">
+    <Import Project="..\..\..\..\..\..\..\build\vs\pjproject-vs14-win32-common-defaults.props" />
+    <Import Project="..\..\..\..\..\..\..\build\vs\pjproject-vs14-release-dynamic-defaults.props" />
+  </ImportGroup>
+  <ImportGroup Label="PropertySheets" Condition="'$(Configuration)|$(Platform)'=='Release|x64'">
+    <Import Project="..\..\..\..\..\..\..\build\vs\pjproject-vs14-win64-common-defaults.props" />
+    <Import Project="..\..\..\..\..\..\..\build\vs\pjproject-vs14-release-dynamic-defaults.props" />
+  </ImportGroup>  
+  <ImportGroup Label="ExtensionSettings">
+  </ImportGroup>
+  <ImportGroup Label="Shared">
+  </ImportGroup>
+  <ImportGroup Label="PropertySheets" Condition="'$(Configuration)|$(Platform)'=='Debug|Win32'">
+    <Import Project="$(UserRootDir)\Microsoft.Cpp.$(Platform).user.props" Condition="exists('$(UserRootDir)\Microsoft.Cpp.$(Platform).user.props')" Label="LocalAppDataPlatform" />
+  </ImportGroup>
+  <ImportGroup Label="PropertySheets" Condition="'$(Configuration)|$(Platform)'=='Release|Win32'">
+    <Import Project="$(UserRootDir)\Microsoft.Cpp.$(Platform).user.props" Condition="exists('$(UserRootDir)\Microsoft.Cpp.$(Platform).user.props')" Label="LocalAppDataPlatform" />
+  </ImportGroup>
+  <ImportGroup Label="PropertySheets" Condition="'$(Configuration)|$(Platform)'=='Debug|ARM'">
+    <Import Project="$(UserRootDir)\Microsoft.Cpp.$(Platform).user.props" Condition="exists('$(UserRootDir)\Microsoft.Cpp.$(Platform).user.props')" Label="LocalAppDataPlatform" />
+  </ImportGroup>
+  <ImportGroup Label="PropertySheets" Condition="'$(Configuration)|$(Platform)'=='Release|ARM'">
+    <Import Project="$(UserRootDir)\Microsoft.Cpp.$(Platform).user.props" Condition="exists('$(UserRootDir)\Microsoft.Cpp.$(Platform).user.props')" Label="LocalAppDataPlatform" />
+  </ImportGroup>
+  <ImportGroup Label="PropertySheets" Condition="'$(Configuration)|$(Platform)'=='Debug|x64'">
+    <Import Project="$(UserRootDir)\Microsoft.Cpp.$(Platform).user.props" Condition="exists('$(UserRootDir)\Microsoft.Cpp.$(Platform).user.props')" Label="LocalAppDataPlatform" />
+  </ImportGroup>
+  <ImportGroup Label="PropertySheets" Condition="'$(Configuration)|$(Platform)'=='Release|x64'">
+    <Import Project="$(UserRootDir)\Microsoft.Cpp.$(Platform).user.props" Condition="exists('$(UserRootDir)\Microsoft.Cpp.$(Platform).user.props')" Label="LocalAppDataPlatform" />
+  </ImportGroup>
+  <PropertyGroup Label="UserMacros" />
+  <PropertyGroup />
+  <PropertyGroup Condition="'$(Configuration)|$(Platform)'=='Debug|Win32'">
+    <GenerateManifest>false</GenerateManifest>
+  </PropertyGroup>
+  <PropertyGroup Condition="'$(Configuration)|$(Platform)'=='Release|Win32'">
+    <GenerateManifest>false</GenerateManifest>
+  </PropertyGroup>
+  <PropertyGroup Condition="'$(Configuration)|$(Platform)'=='Debug|ARM'">
+    <GenerateManifest>false</GenerateManifest>
+  </PropertyGroup>
+  <PropertyGroup Condition="'$(Configuration)|$(Platform)'=='Release|ARM'">
+    <GenerateManifest>false</GenerateManifest>
+  </PropertyGroup>
+  <PropertyGroup Condition="'$(Configuration)|$(Platform)'=='Debug|x64'">
+    <GenerateManifest>false</GenerateManifest>
+  </PropertyGroup>
+  <PropertyGroup Condition="'$(Configuration)|$(Platform)'=='Release|x64'">
+    <GenerateManifest>false</GenerateManifest>
+  </PropertyGroup>
+  <ItemDefinitionGroup Condition="'$(Configuration)|$(Platform)'=='Debug|Win32'">
+    <ClCompile>
+      <PrecompiledHeader>NotUsing</PrecompiledHeader>
+      <PreprocessorDefinitions>_WINRT_DLL;%(PreprocessorDefinitions)</PreprocessorDefinitions>
+      <PrecompiledHeaderFile>pch.h</PrecompiledHeaderFile>
+      <PrecompiledHeaderOutputFile>$(IntDir)pch.pch</PrecompiledHeaderOutputFile>
+      <AdditionalUsingDirectories>$(WindowsSDK_WindowsMetadata);$(AdditionalUsingDirectories)</AdditionalUsingDirectories>
+      <AdditionalOptions>/bigobj %(AdditionalOptions)</AdditionalOptions>
+      <DisableSpecificWarnings>28204</DisableSpecificWarnings>
+      <RuntimeLibrary>MultiThreadedDebugDLL</RuntimeLibrary>
+      <CompileAsWinRT>true</CompileAsWinRT>
+      <AdditionalIncludeDirectories>..\..\..\..\..\..\..\pjsip\include;..\..\..\..\..\..\..\pjlib\include;..\..\..\..\..\..\..\pjlib-util\include;..\..\..\..\..\..\..\pjmedia\include;..\..\..\..\..\..\..\pjnath\include;%(AdditionalIncludeDirectories)</AdditionalIncludeDirectories>
+    </ClCompile>
+    <Link>
+      <SubSystem>Console</SubSystem>
+      <IgnoreAllDefaultLibraries>false</IgnoreAllDefaultLibraries>
+    </Link>
+  </ItemDefinitionGroup>
+  <ItemDefinitionGroup Condition="'$(Configuration)|$(Platform)'=='Release|Win32'">
+    <ClCompile>
+      <PrecompiledHeader>NotUsing</PrecompiledHeader>
+      <PreprocessorDefinitions>_WINRT_DLL;NDEBUG;%(PreprocessorDefinitions)</PreprocessorDefinitions>
+      <PrecompiledHeaderFile>pch.h</PrecompiledHeaderFile>
+      <PrecompiledHeaderOutputFile>$(IntDir)pch.pch</PrecompiledHeaderOutputFile>
+      <AdditionalUsingDirectories>$(WindowsSDK_WindowsMetadata);$(AdditionalUsingDirectories)</AdditionalUsingDirectories>
+      <AdditionalOptions>/bigobj %(AdditionalOptions)</AdditionalOptions>
+      <DisableSpecificWarnings>28204</DisableSpecificWarnings>
+      <AdditionalIncludeDirectories>..\..\..\..\..\..\..\pjsip\include;..\..\..\..\..\..\..\pjlib\include;..\..\..\..\..\..\..\pjlib-util\include;..\..\..\..\..\..\..\pjmedia\include;..\..\..\..\..\..\..\pjnath\include;%(AdditionalIncludeDirectories)</AdditionalIncludeDirectories>
+    </ClCompile>
+    <Link>
+      <SubSystem>Console</SubSystem>
+      <IgnoreAllDefaultLibraries>false</IgnoreAllDefaultLibraries>
+    </Link>
+  </ItemDefinitionGroup>
+  <ItemDefinitionGroup Condition="'$(Configuration)|$(Platform)'=='Debug|ARM'">
+    <ClCompile>
+      <PrecompiledHeader>NotUsing</PrecompiledHeader>
+      <PreprocessorDefinitions>_WINRT_DLL;%(PreprocessorDefinitions)</PreprocessorDefinitions>
+      <PrecompiledHeaderFile>pch.h</PrecompiledHeaderFile>
+      <PrecompiledHeaderOutputFile>$(IntDir)pch.pch</PrecompiledHeaderOutputFile>
+      <AdditionalUsingDirectories>$(WindowsSDK_WindowsMetadata);$(AdditionalUsingDirectories)</AdditionalUsingDirectories>
+      <AdditionalOptions>/bigobj %(AdditionalOptions)</AdditionalOptions>
+      <DisableSpecificWarnings>28204</DisableSpecificWarnings>
+      <RuntimeLibrary>MultiThreadedDebugDLL</RuntimeLibrary>
+      <CompileAsWinRT>true</CompileAsWinRT>
+      <AdditionalIncludeDirectories>..\..\..\..\..\..\..\pjsip\include;..\..\..\..\..\..\..\pjlib\include;..\..\..\..\..\..\..\pjlib-util\include;..\..\..\..\..\..\..\pjmedia\include;..\..\..\..\..\..\..\pjnath\include;%(AdditionalIncludeDirectories)</AdditionalIncludeDirectories>
+    </ClCompile>
+    <Link>
+      <SubSystem>Console</SubSystem>
+      <IgnoreAllDefaultLibraries>false</IgnoreAllDefaultLibraries>
+    </Link>
+  </ItemDefinitionGroup>
+  <ItemDefinitionGroup Condition="'$(Configuration)|$(Platform)'=='Release|ARM'">
+    <ClCompile>
+      <PrecompiledHeader>NotUsing</PrecompiledHeader>
+      <PreprocessorDefinitions>_WINRT_DLL;NDEBUG;%(PreprocessorDefinitions)</PreprocessorDefinitions>
+      <PrecompiledHeaderFile>pch.h</PrecompiledHeaderFile>
+      <PrecompiledHeaderOutputFile>$(IntDir)pch.pch</PrecompiledHeaderOutputFile>
+      <AdditionalUsingDirectories>$(WindowsSDK_WindowsMetadata);$(AdditionalUsingDirectories)</AdditionalUsingDirectories>
+      <AdditionalOptions>/bigobj %(AdditionalOptions)</AdditionalOptions>
+      <DisableSpecificWarnings>28204</DisableSpecificWarnings>
+      <AdditionalIncludeDirectories>..\..\..\..\..\..\..\pjsip\include;..\..\..\..\..\..\..\pjlib\include;..\..\..\..\..\..\..\pjlib-util\include;..\..\..\..\..\..\..\pjmedia\include;..\..\..\..\..\..\..\pjnath\include;%(AdditionalIncludeDirectories)</AdditionalIncludeDirectories>
+    </ClCompile>
+    <Link>
+      <SubSystem>Console</SubSystem>
+      <IgnoreAllDefaultLibraries>false</IgnoreAllDefaultLibraries>
+    </Link>
+  </ItemDefinitionGroup>
+  <ItemDefinitionGroup Condition="'$(Configuration)|$(Platform)'=='Debug|x64'">
+    <ClCompile>
+      <PrecompiledHeader>NotUsing</PrecompiledHeader>
+      <PreprocessorDefinitions>_WINRT_DLL;%(PreprocessorDefinitions)</PreprocessorDefinitions>
+      <PrecompiledHeaderFile>pch.h</PrecompiledHeaderFile>
+      <PrecompiledHeaderOutputFile>$(IntDir)pch.pch</PrecompiledHeaderOutputFile>
+      <AdditionalUsingDirectories>$(WindowsSDK_WindowsMetadata);$(AdditionalUsingDirectories)</AdditionalUsingDirectories>
+      <AdditionalOptions>/bigobj %(AdditionalOptions)</AdditionalOptions>
+      <DisableSpecificWarnings>28204</DisableSpecificWarnings>
+      <RuntimeLibrary>MultiThreadedDebugDLL</RuntimeLibrary>
+      <CompileAsWinRT>true</CompileAsWinRT>
+      <AdditionalIncludeDirectories>..\..\..\..\..\..\..\pjsip\include;..\..\..\..\..\..\..\pjlib\include;..\..\..\..\..\..\..\pjlib-util\include;..\..\..\..\..\..\..\pjmedia\include;..\..\..\..\..\..\..\pjnath\include;%(AdditionalIncludeDirectories)</AdditionalIncludeDirectories>
+    </ClCompile>
+    <Link>
+      <SubSystem>Console</SubSystem>
+      <IgnoreAllDefaultLibraries>false</IgnoreAllDefaultLibraries>
+    </Link>
+  </ItemDefinitionGroup>
+  <ItemDefinitionGroup Condition="'$(Configuration)|$(Platform)'=='Release|x64'">
+    <ClCompile>
+      <PrecompiledHeader>NotUsing</PrecompiledHeader>
+      <PreprocessorDefinitions>_WINRT_DLL;NDEBUG;%(PreprocessorDefinitions)</PreprocessorDefinitions>
+      <PrecompiledHeaderFile>pch.h</PrecompiledHeaderFile>
+      <PrecompiledHeaderOutputFile>$(IntDir)pch.pch</PrecompiledHeaderOutputFile>
+      <AdditionalUsingDirectories>$(WindowsSDK_WindowsMetadata);$(AdditionalUsingDirectories)</AdditionalUsingDirectories>
+      <AdditionalOptions>/bigobj %(AdditionalOptions)</AdditionalOptions>
+      <DisableSpecificWarnings>28204</DisableSpecificWarnings>
+      <AdditionalIncludeDirectories>..\..\..\..\..\..\..\pjsip\include;..\..\..\..\..\..\..\pjlib\include;..\..\..\..\..\..\..\pjlib-util\include;..\..\..\..\..\..\..\pjmedia\include;..\..\..\..\..\..\..\pjnath\include;%(AdditionalIncludeDirectories)</AdditionalIncludeDirectories>
+    </ClCompile>
+    <Link>
+      <SubSystem>Console</SubSystem>
+      <IgnoreAllDefaultLibraries>false</IgnoreAllDefaultLibraries>
+    </Link>
+  </ItemDefinitionGroup>
+  <ItemGroup Condition="'$(API_Family)'=='UWP'">
+    <ClInclude Include="ApiLock.h" />
+    <ClInclude Include="pch.h" />
+  </ItemGroup>
+  <ItemGroup Condition="'$(API_Family)'=='UWP'">
+    <ClCompile Include="ApiLock.cpp" />
+    <ClCompile Include="pch.cpp">
+      <PrecompiledHeader Condition="'$(Configuration)|$(Platform)'=='Debug|Win32'">Create</PrecompiledHeader>
+      <PrecompiledHeader Condition="'$(Configuration)|$(Platform)'=='Release|Win32'">Create</PrecompiledHeader>
+      <PrecompiledHeader Condition="'$(Configuration)|$(Platform)'=='Debug|ARM'">Create</PrecompiledHeader>
+      <PrecompiledHeader Condition="'$(Configuration)|$(Platform)'=='Release|ARM'">Create</PrecompiledHeader>
+      <PrecompiledHeader Condition="'$(Configuration)|$(Platform)'=='Debug|x64'">Create</PrecompiledHeader>
+      <PrecompiledHeader Condition="'$(Configuration)|$(Platform)'=='Release|x64'">Create</PrecompiledHeader>
+    </ClCompile>
+  </ItemGroup>
+  <ItemGroup>
+    <ClCompile Include="MyApp.cpp" />
+  </ItemGroup>
+  <ItemGroup>
+    <ClInclude Include="MyApp.h" />
+  </ItemGroup>
+  <!--Don't build this project unless it's for UWP-->
+  <Import Condition="'$(API_Family)'=='UWP'" Project="$(VCTargetsPath)\Microsoft.Cpp.targets" />
+  <Import Condition="'$(API_Family)'!='UWP'" Project="..\..\..\..\..\..\..\build\vs\pjproject-vs14-build-targets.targets" />
+  <ImportGroup Label="ExtensionTargets">
+  </ImportGroup>
+</Project>
Index: /pjproject/trunk/pjsip-apps/src/pjsua/winrt/gui/uwp/VoipBackEnd/VoipBackEnd.vcxproj.filters
===================================================================
--- /pjproject/trunk/pjsip-apps/src/pjsua/winrt/gui/uwp/VoipBackEnd/VoipBackEnd.vcxproj.filters	(revision 5539)
+++ /pjproject/trunk/pjsip-apps/src/pjsua/winrt/gui/uwp/VoipBackEnd/VoipBackEnd.vcxproj.filters	(revision 5539)
@@ -0,0 +1,19 @@
+﻿<?xml version="1.0" encoding="utf-8"?>
+<Project ToolsVersion="14.0" xmlns="http://schemas.microsoft.com/developer/msbuild/2003">
+  <ItemGroup>
+    <Filter Include="Resources">
+      <UniqueIdentifier>d25e3c8e-e29b-40f8-88c6-2cb35dbe70d2</UniqueIdentifier>
+      <Extensions>rc;ico;cur;bmp;dlg;rc2;rct;bin;rgs;gif;jpg;jpeg;jpe;resx;tga;tiff;tif;png;wav;mfcribbon-ms</Extensions>
+    </Filter>
+  </ItemGroup>
+  <ItemGroup>
+    <ClCompile Include="pch.cpp" />
+    <ClCompile Include="ApiLock.cpp" />
+    <ClCompile Include="MyApp.cpp" />
+  </ItemGroup>
+  <ItemGroup>
+    <ClInclude Include="pch.h" />
+    <ClInclude Include="ApiLock.h" />
+    <ClInclude Include="MyApp.h" />
+  </ItemGroup>
+</Project>
Index: /pjproject/trunk/pjsip-apps/src/pjsua/winrt/gui/uwp/VoipBackEnd/pch.cpp
===================================================================
--- /pjproject/trunk/pjsip-apps/src/pjsua/winrt/gui/uwp/VoipBackEnd/pch.cpp	(revision 5539)
+++ /pjproject/trunk/pjsip-apps/src/pjsua/winrt/gui/uwp/VoipBackEnd/pch.cpp	(revision 5539)
@@ -0,0 +1,11 @@
+﻿//*********************************************************
+//
+// Copyright (c) Microsoft. All rights reserved.
+// This code is licensed under the MIT License (MIT).
+// THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
+// ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
+// IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
+// PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
+//
+//*********************************************************
+#include "pch.h"
Index: /pjproject/trunk/pjsip-apps/src/pjsua/winrt/gui/uwp/VoipBackEnd/pch.h
===================================================================
--- /pjproject/trunk/pjsip-apps/src/pjsua/winrt/gui/uwp/VoipBackEnd/pch.h	(revision 5539)
+++ /pjproject/trunk/pjsip-apps/src/pjsua/winrt/gui/uwp/VoipBackEnd/pch.h	(revision 5539)
@@ -0,0 +1,14 @@
+﻿//*********************************************************
+//
+// Copyright (c) Microsoft. All rights reserved.
+// This code is licensed under the MIT License (MIT).
+// THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
+// ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
+// IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
+// PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
+//
+//*********************************************************
+#pragma once
+
+#include <collection.h>
+#include <ppltasks.h>
Index: /pjproject/trunk/pjsip-apps/src/pjsua/winrt/gui/uwp/VoipHost/VoipHost.cpp
===================================================================
--- /pjproject/trunk/pjsip-apps/src/pjsua/winrt/gui/uwp/VoipHost/VoipHost.cpp	(revision 5539)
+++ /pjproject/trunk/pjsip-apps/src/pjsua/winrt/gui/uwp/VoipHost/VoipHost.cpp	(revision 5539)
@@ -0,0 +1,55 @@
+//*********************************************************
+//
+// Copyright (c) Microsoft. All rights reserved.
+// This code is licensed under the MIT License (MIT).
+// THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
+// ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
+// IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
+// PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
+//
+//*********************************************************
+
+#include <wrl\module.h>
+#include <roapi.h>
+#include <Windows.ApplicationModel.Core.h>
+
+using namespace ABI::Windows::ApplicationModel::Core;
+using namespace Microsoft::WRL;
+
+class ExeServerGetActivationFactory : public RuntimeClass<
+    ABI::Windows::Foundation::IGetActivationFactory,
+    FtmBase>
+{
+public:
+    IFACEMETHODIMP GetActivationFactory(_In_ HSTRING activatableClassId, _COM_Outptr_ IInspectable **factory)
+    {
+        *factory = nullptr;
+        ComPtr<IActivationFactory> activationFactory;
+        auto &module = Microsoft::WRL::Module<Microsoft::WRL::InProc>::GetModule();
+        HRESULT hr = module.GetActivationFactory(activatableClassId, &activationFactory);
+        if (SUCCEEDED(hr))
+        {
+            *factory = activationFactory.Detach();
+        }
+        return hr;
+    }
+};
+
+int CALLBACK WinMain(_In_  HINSTANCE, _In_  HINSTANCE, _In_  LPSTR, _In_  int)
+{
+    HRESULT hr = Windows::Foundation::Initialize(RO_INIT_MULTITHREADED);
+    if (SUCCEEDED(hr))
+    {
+        // Scoping for smart pointers
+        {
+            ComPtr<ICoreApplication> spApplicationFactory;
+            hr = Windows::Foundation::GetActivationFactory(Wrappers::HStringReference(RuntimeClass_Windows_ApplicationModel_Core_CoreApplication).Get(), &spApplicationFactory);
+            if (SUCCEEDED(hr))
+            {
+                ComPtr<ABI::Windows::Foundation::IGetActivationFactory> spGetActivationFactory = Make<ExeServerGetActivationFactory>();
+                spApplicationFactory->RunWithActivationFactories(spGetActivationFactory.Get());
+            }
+        }
+        Windows::Foundation::Uninitialize();
+    }
+}
